diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/cp/repo.c gcc-3.4.4-3/gcc/cp/repo.c
--- gcc-3.4.4-3-orig/gcc/cp/repo.c	2003-12-19 23:28:10.000000000 +0000
+++ gcc-3.4.4-3/gcc/cp/repo.c	2006-05-13 17:35:16.000000000 +0100
@@ -1,5 +1,5 @@
 /* Code to maintain a C++ template repository.
-   Copyright (C) 1995, 1996, 1997, 1998, 2000, 2001, 2002, 2003
+   Copyright (C) 1995, 1996, 1997, 1998, 2000, 2001, 2002, 2003, 2004
    Free Software Foundation, Inc.
    Contributed by Jason Merrill (jason@cygnus.com)
 
@@ -53,8 +53,8 @@
 
 static struct obstack temporary_obstack;
 
-#define IDENTIFIER_REPO_USED(NODE)   (TREE_LANG_FLAG_3 (NODE))
-#define IDENTIFIER_REPO_CHOSEN(NODE) (TREE_LANG_FLAG_4 (NODE))
+#define IDENTIFIER_REPO_USED(NODE)   (TREE_LANG_FLAG_5 (NODE))
+#define IDENTIFIER_REPO_CHOSEN(NODE) (TREE_LANG_FLAG_6 (NODE))
 
 #if 0
 /* Record the flags used to compile this translation unit.  */
@@ -218,7 +218,10 @@
 	break;
       ++p;
       if (backquote)
-	obstack_1grow (&temporary_obstack, c);
+	{
+	  obstack_1grow (&temporary_obstack, c);
+	  backquote = 0;
+	}
       else if (! inside && c == ' ')
 	break;
       else if (! inside && c == '\\')
@@ -249,7 +252,7 @@
 	output = extract_string (&p);
       else if (strcmp (q, "-c") == 0)
 	compiling = 1;
-      }
+    }
 
   if (compiling && output)
     return output;
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/cp/typeck.c gcc-3.4.4-3/gcc/cp/typeck.c
--- gcc-3.4.4-3-orig/gcc/cp/typeck.c	2005-05-02 19:38:44.000000000 +0100
+++ gcc-3.4.4-3/gcc/cp/typeck.c	2006-05-13 17:35:16.000000000 +0100
@@ -2432,9 +2432,10 @@
 
       /* Differs from default_conversion by not setting TREE_ADDRESSABLE
 	 (because calling an inline function does not mean the function
-	 needs to be separately compiled).  */
+	 needs to be separately compiled, unless separate compilation
+	 has been requested).  */
       
-      if (DECL_INLINE (function))
+      if (DECL_INLINE (function) && !flag_keep_inline_functions)
 	function = inline_conversion (function);
       else
 	function = build_addr_func (function);
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/cppfiles.c gcc-3.4.4-3/gcc/cppfiles.c
--- gcc-3.4.4-3-orig/gcc/cppfiles.c	2004-12-15 13:41:18.000000000 +0000
+++ gcc-3.4.4-3/gcc/cppfiles.c	2006-05-13 17:35:16.000000000 +0100
@@ -233,6 +233,15 @@
   else if (errno == ENOTDIR)
     errno = ENOENT;
 
+#if 1
+   /* An attempt to open() a directory fails and sets errno to EACCES, at
+      least on some hosts.  Check and reset errno to ENOENT.  */
+  else if (errno == EACCES
+	   && stat (file->path, &file->st) == 0
+	   && S_ISDIR (file->st.st_mode))
+    errno = ENOENT; 	    
+#endif
+
   file->err_no = errno;
 
   return false;
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/crtstuff.c gcc-3.4.4-3/gcc/crtstuff.c
--- gcc-3.4.4-3-orig/gcc/crtstuff.c	2004-10-14 00:29:04.000000000 +0100
+++ gcc-3.4.4-3/gcc/crtstuff.c	2005-06-03 21:03:34.000000000 +0100
@@ -134,6 +134,8 @@
 /* Likewise for _Jv_RegisterClasses.  */
 extern void _Jv_RegisterClasses (void *) TARGET_ATTRIBUTE_WEAK;
 
+#if !(defined (__MINGW32__) || defined (__CYGWIN__))
+
 #ifdef OBJECT_FORMAT_ELF
 
 /*  Declare a pointer to void function type.  */
@@ -542,3 +544,108 @@
 #else /* ! CRT_BEGIN && ! CRT_END */
 #error "One of CRT_BEGIN or CRT_END must be defined."
 #endif
+
+#else /*__MINGW32__ || __CYGWIN__ */
+
+/* Use  __main to run ctors and dtors. This code generates a
+label for beginning of .eh_frame section in crtbegin.o and terminates
+the section in crtend.o. Registration and deregistration is done by
+installing ctor and dtor functions to do the job.  */
+
+  
+#ifdef CRT_BEGIN
+
+extern  void __w32_sharedptr_initialize(void);
+
+/* Stick a label at the beginning of the frame unwind info so we can
+   register/deregister it with the exception handling library code.  */
+#if defined (USE_EH_FRAME_REGISTRY) \
+	     && !__USING_SJLJ_EXCEPTIONS__
+char __EH_FRAME_BEGIN__[]
+     __attribute__((section(EH_FRAME_SECTION_NAME), aligned(4)))
+     = { };
+
+static struct object obj;
+
+/* These will pull in references from libgcc.a(unwind-dw2-fde.o) */
+
+void __do_frame_init (void);
+void __do_frame_fini (void);
+
+void
+__do_frame_init (void)
+{
+  __w32_sharedptr_initialize();
+  __register_frame_info (__EH_FRAME_BEGIN__, &obj);
+}
+
+void
+__do_frame_fini (void)
+{
+  __deregister_frame_info (__EH_FRAME_BEGIN__);
+}
+#else /* USE_EH_FRAME_REGISTRY && !__USING_SJLJ__EXCEPTIONS__ */
+void __do_sjlj_init (void);
+
+void
+__do_sjlj_init (void)
+{
+  __w32_sharedptr_initialize();
+}
+#endif
+
+
+#elif defined CRT_END
+
+/* Terminate the frame unwind info section with a 0 as a sentinel;
+   this would be the 'length' field in a real FDE.  */
+#if defined (USE_EH_FRAME_REGISTRY) \
+	     && !__USING_SJLJ_EXCEPTIONS__
+static int __EH_FRAME_END__[]
+     __attribute__ ((unused, mode(SI), section(EH_FRAME_SECTION_NAME),
+		     aligned(4)))
+     = { 0 };
+static void __reg_frame_ctor (void) __attribute__ ((constructor));
+static void __dereg_frame_dtor (void) __attribute__ ((destructor));
+extern void __do_frame_init (void);
+extern void __do_frame_fini (void);
+
+
+/* Register the eh_frame. This has to be the first ctor to
+   be invoked so we put it in last. Since we're last, we can't
+   reference __register_frame_info in libgcc.a directly (if eh_frame
+   code has been referenced than it will have been pulled in but
+   we can't count on it) so we  call a thunk in crtbegin.o.  */
+
+static void
+__reg_frame_ctor (void)
+{
+  __do_frame_init ();
+}
+
+/* Deregister the eh_frame. This has to be the last dtor. The
+   call to __register_frame_info in crtbegin.o will have pulled in
+   libgcc.a(unwind-dw2-fde.o) if libgcc.a is static lib but not if
+   dll, so we use a thunk again to be sure.  */
+
+static void
+__dereg_frame_dtor (void)
+{
+  __do_frame_fini ();
+}
+#else
+static void __sjlj_init_ctor (void) __attribute__ ((constructor));
+void __do_sjlj_init (void);
+static void
+__sjlj_init_ctor (void)
+{
+  __do_sjlj_init ();
+}
+
+#endif /* USE_EH_FRAME_REGISTRY && !__USING_SJLJ__EXCEPTIONS__ */
+
+#else /* ! CRT_BEGIN && ! CRT_END */
+#error "One of CRT_BEGIN or CRT_END must be defined."
+#endif
+
+#endif /* __MINGW32__ || __CYGWIN__ */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/dbxout.c gcc-3.4.4-3/gcc/dbxout.c
--- gcc-3.4.4-3-orig/gcc/dbxout.c	2005-01-27 02:01:54.000000000 +0000
+++ gcc-3.4.4-3/gcc/dbxout.c	2006-05-17 02:44:56.000000000 +0100
@@ -1470,7 +1470,7 @@
 	  fputs ("@s", asmfile);
 	  CHARS (2);
 	  print_wide_int (BITS_PER_UNIT * int_size_in_bytes (type));
-	  fputs (";-20;", asmfile);
+	  fputs (";-20", asmfile);
 	  CHARS (4);
 	}
       else
@@ -1492,7 +1492,7 @@
 	  fputs ("@s", asmfile);
 	  CHARS (2);
 	  print_wide_int (BITS_PER_UNIT * int_size_in_bytes (type));
-	  fputs (";-16;", asmfile);
+	  fputs (";-16", asmfile);
 	  CHARS (4);
 	}
       else /* Define as enumeral type (False, True) */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/defaults.h gcc-3.4.4-3/gcc/defaults.h
--- gcc-3.4.4-3-orig/gcc/defaults.h	2005-01-16 16:01:18.000000000 +0000
+++ gcc-3.4.4-3/gcc/defaults.h	2005-06-03 21:03:34.000000000 +0100
@@ -696,4 +696,11 @@
 #define EXIT_IGNORE_STACK 0
 #endif
 
+/* This should, in the abstract, be the empty string.  However,
+   historically, GCC has accepted GLIBC's "I" flag character on all
+   systems.  */
+#ifndef TARGET_EXTRA_PRINTF_FLAG_CHARS
+#define TARGET_EXTRA_PRINTF_FLAG_CHARS "I"
+#endif
+
 #endif  /* ! GCC_DEFAULTS_H */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/dwarf2out.c gcc-3.4.4-3/gcc/dwarf2out.c
--- gcc-3.4.4-3-orig/gcc/dwarf2out.c	2005-05-11 02:51:40.000000000 +0100
+++ gcc-3.4.4-3/gcc/dwarf2out.c	2006-05-17 02:44:56.000000000 +0100
@@ -8636,6 +8636,9 @@
     case VIEW_CONVERT_EXPR:
     case SAVE_EXPR:
     case MODIFY_EXPR:
+#ifdef GPC
+    case UNSAVE_EXPR:
+#endif
       return loc_descriptor_from_tree (TREE_OPERAND (loc, 0), addressp);
 
     case COMPONENT_REF:
@@ -8693,7 +8696,7 @@
 	rtx rtl = lookup_constant_def (loc);
 	enum machine_mode mode;
 
-	if (GET_CODE (rtl) != MEM)
+	if (!rtl || GET_CODE (rtl) != MEM)
 	  return 0;
 	mode = GET_MODE (rtl);
 	rtl = XEXP (rtl, 0);
@@ -8838,6 +8841,15 @@
       add_loc_descr (&ret, new_loc_descr (op, 0, 0));
       break;
 
+#ifdef GPC
+    case MIN_EXPR:
+      loc = build (COND_EXPR, TREE_TYPE (loc),
+		   build (GT_EXPR, integer_type_node,
+			  TREE_OPERAND (loc, 0), TREE_OPERAND (loc, 1)),
+		   TREE_OPERAND (loc, 1), TREE_OPERAND (loc, 0));
+      goto cond_expr;
+#endif
+
     case MAX_EXPR:
       loc = build (COND_EXPR, TREE_TYPE (loc),
 		   build (LT_EXPR, integer_type_node,
@@ -8847,6 +8859,9 @@
       /* ... fall through ...  */
 
     case COND_EXPR:
+#ifdef GPC
+    cond_expr:
+#endif
       {
 	dw_loc_descr_ref lhs
 	  = loc_descriptor_from_tree (TREE_OPERAND (loc, 1), 0);
@@ -8877,6 +8892,18 @@
       }
       break;
 
+#ifdef GPC
+    case REAL_CST:
+    case FLOAT_EXPR:
+    case RDIV_EXPR:
+    case STRING_CST:
+      /* In Pascal it's possible for array bounds to contain floating point
+         expressions (e.g., p/test/emil11c.pas). I don't know if it's
+         possible to represent them in dwarf2, but it doesn't seem terribly
+         important since this occurs quite rarely. -- Frank */
+      return 0;
+#endif
+
     case EXPR_WITH_FILE_LOCATION:
       return loc_descriptor_from_tree (EXPR_WFL_NODE (loc), addressp);
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/expr.c gcc-3.4.4-3/gcc/expr.c
--- gcc-3.4.4-3-orig/gcc/expr.c	2005-05-11 22:19:48.000000000 +0100
+++ gcc-3.4.4-3/gcc/expr.c	2006-05-17 02:44:56.000000000 +0100
@@ -19,6 +19,9 @@
 Software Foundation, 59 Temple Place - Suite 330, Boston, MA
 02111-1307, USA.  */
 
+
+/* @@ PATCHED FOR GPC @@ */
+
 #include "config.h"
 #include "system.h"
 #include "coretypes.h"
@@ -5078,13 +5081,36 @@
 	  return;
 	}
 
+#ifndef GPC
       domain_min = convert (sizetype, TYPE_MIN_VALUE (domain));
       domain_max = convert (sizetype, TYPE_MAX_VALUE (domain));
+#else /* GPC */
+      domain_min = convert (sbitsizetype, TYPE_MIN_VALUE (domain));
+      domain_max = convert (sbitsizetype, TYPE_MAX_VALUE (domain));
+
+      /* Align the set.  */
+      if (set_alignment)
+        domain_min = size_binop (BIT_AND_EXPR, domain_min, sbitsize_int (-(int) set_alignment));
+
+#endif /* GPC */
       bitlength = size_binop (PLUS_EXPR,
-			      size_diffop (domain_max, domain_min),
+			      size_binop (MINUS_EXPR, domain_max, domain_min),
+#ifndef GPC
 			      ssize_int (1));
+#else /* GPC */
+			      sbitsize_int (1));
+#endif /* GPC */
 
+#ifdef GPC
+      if (TREE_INT_CST_HIGH (bitlength)) {
+        error ("set size too big for host integers");
+        return;
+      }
+#endif /* GPC */
       nbits = tree_low_cst (bitlength, 1);
+#ifdef GPC
+      bitlength = convert (sizetype, bitlength);
+#endif /* GPC */
 
       /* For "small" sets, or "medium-sized" (up to 32 bytes) sets that
 	 are "complicated" (more than one range), initialize (the
@@ -5092,7 +5118,9 @@
       if (GET_MODE (target) != BLKmode || nbits <= 2 * BITS_PER_WORD
 	  || (nbytes <= 32 && TREE_CHAIN (elt) != NULL_TREE))
 	{
+#ifndef GPC
 	  unsigned int set_word_size = TYPE_ALIGN (TREE_TYPE (exp));
+#endif /* not GPC */
 	  enum machine_mode mode = mode_for_size (set_word_size, MODE_INT, 1);
 	  char *bit_buffer = alloca (nbits);
 	  HOST_WIDE_INT word = 0;
@@ -5105,10 +5133,14 @@
 	    {
 	      if (bit_buffer[ibit])
 		{
+#ifndef GPC
 		  if (BYTES_BIG_ENDIAN)
-		    word |= (1 << (set_word_size - 1 - bit_pos));
+#else /* GPC */
+		  if (set_words_big_endian)
+#endif /* GPC */
+		    word |= (((HOST_WIDE_INT)1) << (set_word_size - 1 - bit_pos));
 		  else
-		    word |= 1 << bit_pos;
+		    word |= ((HOST_WIDE_INT)1) << bit_pos;
 		}
 
 	      bit_pos++;  ibit++;
@@ -5140,6 +5172,11 @@
 	    }
 	}
       else if (!cleared)
+   /* GPC expects bits outside the range to be cleared. (fjf1010.pas)
+      Though this check might be "dead" in this GCC version since it only
+      applies to single ranges with constant bounds, and those are apparently
+      always stored as constants anyway, not initialized via `__setbits'. */
+#ifndef GPC
 	/* Don't bother clearing storage if the set is all ones.  */
 	if (TREE_CHAIN (elt) != NULL_TREE
 	    || (TREE_PURPOSE (elt) == NULL_TREE
@@ -5149,6 +5186,7 @@
 		   || (tree_low_cst (TREE_VALUE (elt), 0)
 		       - tree_low_cst (TREE_PURPOSE (elt), 0) + 1
 		       != (HOST_WIDE_INT) nbits))))
+#endif
 	  clear_storage (target, expr_size (exp));
 
       for (; elt != NULL_TREE; elt = TREE_CHAIN (elt))
@@ -5170,13 +5208,23 @@
 	      endbit = startbit;
 	    }
 
+#ifndef GPC
 	  startbit = convert (sizetype, startbit);
 	  endbit = convert (sizetype, endbit);
+#endif /* not GPC */
 	  if (! integer_zerop (domain_min))
 	    {
+#ifdef GPC
+	      startbit = convert (sbitsizetype, startbit);
+	      endbit = convert (sbitsizetype, endbit);
+#endif /* GPC */
 	      startbit = size_binop (MINUS_EXPR, startbit, domain_min);
 	      endbit = size_binop (MINUS_EXPR, endbit, domain_min);
 	    }
+#ifdef GPC
+	  startbit = convert (sizetype, startbit);
+	  endbit = convert (sizetype, endbit);
+#endif /* GPC */
 	  startbit_rtx = expand_expr (startbit, NULL_RTX, MEM,
 				      EXPAND_CONST_ADDRESS);
 	  endbit_rtx = expand_expr (endbit, NULL_RTX, MEM,
@@ -5542,8 +5590,18 @@
 	     index, then convert to sizetype and multiply by the size of the
 	     array element.  */
 	  if (low_bound != 0 && ! integer_zerop (low_bound))
+#ifdef GPC
+	    /* I think that address arithmetic should always be done on sizetype or
+	       its variants -- for Pascal signed seems to be the correct choice (and
+	       generates slightly better code). -- Waldek */
+	    index = convert (sizetype, convert (bitsizetype,
+	              size_binop (MINUS_EXPR,
+	                convert (sbitsizetype, index),
+	                convert (sbitsizetype, low_bound))));
+#else
 	    index = fold (build (MINUS_EXPR, TREE_TYPE (index),
 				 index, low_bound));
+#endif
 
 	  /* If the index has a self-referential type, pass it to a
 	     WITH_RECORD_EXPR; if the component size is, pass our
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/fold-const.c gcc-3.4.4-3/gcc/fold-const.c
--- gcc-3.4.4-3-orig/gcc/fold-const.c	2005-02-11 21:12:48.000000000 +0000
+++ gcc-3.4.4-3/gcc/fold-const.c	2006-05-17 02:44:58.000000000 +0100
@@ -19,6 +19,9 @@
 Software Foundation, 59 Temple Place - Suite 330, Boston, MA
 02111-1307, USA.  */
 
+
+/* @@ PATCHED FOR GPC @@ */
+
 /*@@ This file should be rewritten to use an arbitrary precision
   @@ representation for "struct tree_int_cst" and "struct tree_real_cst".
   @@ Perhaps the routines could also be used for bc/dc, and made a lib.
@@ -225,6 +228,17 @@
 	    && TYPE_IS_SIZETYPE (TREE_TYPE (t))))
     return overflow;
 
+#ifdef GPC
+  /* Sign extension for unsigned types (sizetype) seems quite wrong.
+     Though the previous comment says otherwise, but according to the
+     GCC ChangeLog entry of 2000-10-20, I suppose it was meant only
+     to allow for overflows, not to sign extension, for sizetypes.
+     The problem shows, e.g., when converting a bitsizetype to
+     sizetype where the value doesn't fit in ssizetype. -- Frank */
+  if (!TREE_UNSIGNED (TREE_TYPE (t)))
+  {
+#endif
+
   /* If the value's sign bit is set, extend the sign.  */
   if (prec != 2 * HOST_BITS_PER_WIDE_INT
       && (prec > HOST_BITS_PER_WIDE_INT
@@ -247,6 +261,10 @@
 	}
     }
 
+#ifdef GPC
+  }
+#endif
+
   /* Return nonzero if signed overflow occurred.  */
   return
     ((overflow | (low ^ TREE_INT_CST_LOW (t)) | (high ^ TREE_INT_CST_HIGH (t)))
@@ -1343,10 +1361,14 @@
     }
 
   TREE_OVERFLOW (t)
+#ifndef GPC
     = ((notrunc
 	? (!uns || is_sizetype) && overflow
 	: (force_fit_type (t, (!uns || is_sizetype) && overflow)
 	   && ! no_overflow))
+#else /* GPC */
+	  = ((notrunc ? overflow : force_fit_type (t, overflow))
+#endif /* GPC */
        | TREE_OVERFLOW (arg1)
        | TREE_OVERFLOW (arg2));
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/function.c gcc-3.4.4-3/gcc/function.c
--- gcc-3.4.4-3-orig/gcc/function.c	2005-05-11 22:19:50.000000000 +0100
+++ gcc-3.4.4-3/gcc/function.c	2006-05-17 02:44:58.000000000 +0100
@@ -38,6 +38,8 @@
    This function changes the DECL_RTL to be a stack slot instead of a reg
    then scans all the RTL instructions so far generated to correct them.  */
 
+/* @@ PATCHED FOR GPC @@ */
+
 #include "config.h"
 #include "system.h"
 #include "coretypes.h"
@@ -7004,8 +7006,13 @@
       tramp = round_trampoline_addr (XEXP (tramp, 0));
 #ifdef TRAMPOLINE_TEMPLATE
       blktramp = replace_equiv_address (initial_trampoline, tramp);
+#ifndef GPC
       emit_block_move (blktramp, initial_trampoline,
 		       GEN_INT (TRAMPOLINE_SIZE), BLOCK_OP_NORMAL);
+#else
+      emit_block_move (blktramp, initial_trampoline,
+                       GEN_INT (TRAMPOLINE_SIZE), BLOCK_OP_NO_LIBCALL);
+#endif
 #endif
       trampolines_created = 1;
       INITIALIZE_TRAMPOLINE (tramp, XEXP (DECL_RTL (function), 0), context);
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/gcc.c gcc-3.4.4-3/gcc/gcc.c
--- gcc-3.4.4-3-orig/gcc/gcc.c	2005-05-01 11:33:14.000000000 +0100
+++ gcc-3.4.4-3/gcc/gcc.c	2006-11-19 18:15:24.000000000 +0000
@@ -88,7 +88,7 @@
 #ifdef HAVE_SYS_RESOURCE_H
 #include <sys/resource.h>
 #endif
-#if defined (HAVE_DECL_GETRUSAGE) && !HAVE_DECL_GETRUSAGE
+#if defined (HAVE_GETRUSAGE) && defined (HAVE_DECL_GETRUSAGE) && !HAVE_DECL_GETRUSAGE
 extern int getrusage (int, struct rusage *);
 #endif
 
@@ -767,10 +767,15 @@
 static const char *cc1_options =
 "%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  %1 %{!Q:-quiet} -dumpbase %B %{d*} %{m*} %{a*}\
- %{c|S:%{o*:-auxbase-strip %*}%{!o*:-auxbase %b}}%{!c:%{!S:-auxbase %b}}\
- %{g*} %{O*} %{W*&pedantic*} %{w} %{std*&ansi&trigraphs}\
- %{v:-version} %{pg:-p} %{p} %{f*} %{undef}\
- %{Qn:-fno-ident} %{--help:--help}\
+ %{c|S:%{o*:-auxbase-strip %*}%{!o*:-auxbase %b}}%{!c:%{!S:-auxbase %b}} "
+#ifdef GPC
+"%{g*} %{O*} %{f*&W*&pedantic*&w} %{std*&ansi&trigraphs}\
+ %{v:-version} %{pg:-p} %{p} %{undef}"
+#else /* !GPC */
+"%{g*} %{O*} %{W*&pedantic*} %{w} %{std*&ansi&trigraphs}\
+ %{v:-version} %{pg:-p} %{p} %{f*} %{undef}"
+#endif
+" %{Qn:-fno-ident} %{--help:--help}\
  %{--target-help:--target-help}\
  %{!fsyntax-only:%{S:%W{o*}%{!o*:-o %b.s}}}\
  %{fsyntax-only:-o %j} %{-param*}";
@@ -3174,7 +3179,7 @@
 			  (argc + 1) * sizeof (argv[0]));
       new_argv[0] = new_argv0;
 
-      execvp (new_argv0, new_argv);
+      execvp (new_argv0, (const char *const *)new_argv);
       fatal ("couldn't run `%s': %s", new_argv0, xstrerror (errno));
     }
 
@@ -4155,7 +4160,9 @@
 static int suffixed_basename_length;
 static const char *input_basename;
 static const char *input_suffix;
+#ifndef HOST_FILE_ID_CMP
 static struct stat input_stat;
+#endif
 static int input_stat_set;
 
 /* The compiler used to process the current input file.  */
@@ -4706,6 +4713,9 @@
 		    *((char *) temp_filename + temp_filename_length) = '\0';
 		    if (strcmp (temp_filename, input_filename) != 0)
 		      {
+#if defined HOST_FILE_ID_CMP
+			if (HOST_FILE_ID_CMP(input_filename, temp_filename) != 0)
+#else
 			struct stat st_temp;
 
 			/* Note, set_input() resets input_stat_set to 0.  */
@@ -4725,6 +4735,7 @@
 			    || stat (temp_filename, &st_temp) < 0
 			    || input_stat.st_dev != st_temp.st_dev
 			    || input_stat.st_ino != st_temp.st_ino)
+#endif
 			  {
 			    temp_filename = save_string (temp_filename,
 							 temp_filename_length + 1);
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ggc-common.c gcc-3.4.4-3/gcc/ggc-common.c
--- gcc-3.4.4-3-orig/gcc/ggc-common.c	2003-10-29 22:14:00.000000000 +0000
+++ gcc-3.4.4-3/gcc/ggc-common.c	2006-05-13 17:35:34.000000000 +0100
@@ -650,7 +650,7 @@
   if (needs_read)
     {
       if (fseek (f, mmi.offset, SEEK_SET) != 0
-	  || fread (&mmi, mmi.size, 1, f) != 1)
+	  || fread (mmi.preferred_base, mmi.size, 1, f) != 1)
 	fatal_error ("can't read PCH file: %m");
     }
   else if (fseek (f, mmi.offset + mmi.size, SEEK_SET) != 0)
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ggc.h gcc-3.4.4-3/gcc/ggc.h
--- gcc-3.4.4-3-orig/gcc/ggc.h	2003-12-21 14:08:34.000000000 +0000
+++ gcc-3.4.4-3/gcc/ggc.h	2006-05-13 17:35:34.000000000 +0100
@@ -287,4 +287,8 @@
 extern int ggc_min_heapsize_heuristic (void);
 extern void init_ggc_heuristics (void);
 
+#if defined(_WIN32) && ! defined(__CYGWIN__) && ! defined (_UWIN)
+#define getpagesize() 4096
+#endif
+
 #endif
